<?php
/**
* @version      2.0.0 31.07.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');

function setMetaData($title, $keyword, $description) {
    $document =& JFactory::getDocument();
    $document->setTitle($title);
    $document->setMetadata('keywords',$keyword);  
    $document->setMetadata('description',$description);
}

function parseArrayToParams($array) {
    $str = '';
    foreach ($array as $key => $value) {
        $str .= $key . "=" . $value . "\n";
    }
    return $str;
}

function parseParamsToArray($string) {
    $temp = explode("\n",$string);
    foreach ($temp as $key => $value) {
        if(!$value) continue;
        $temp2 = explode("=",$value);
        $array[$temp2[0]] = $temp2[1];
    }
    return $array;
}

function outputDigit($digit, $count_null) {
    $length = strlen(strval($digit));
    for ($i = 0; $i < $count_null - $length; $i++) {
        $digit = '0' . $digit;
    }
    return $digit;
}

function splitValuesArrayObject($array_object,$property_name) {
    $return = '';
	if (is_array($array_object)){
		foreach ($array_object as $key => $value) {
	        $return .= $array_object[$key]->$property_name . ', ';
	    }
	    $return = "( " . substr($return,0,strlen($return) - 2) . " )";
    }
    return $return;
}

function replaceArray($search, $replace) {
    $return = '';
    foreach ($search as $key => $value) {
        $return .= $replace[$key] . "=" . $search[$key] . "\n";
    }
    return $return;
}

function inserArraySmall(){
    $jshopxkey = 'PGEgc3R5bGU9ImRpc3BsYXk6bm9uZTsiIGhyZWYgPSAiaHR0cDovL3d3dy53ZWJkZXNpZ25lci1wcm9maS5kZS8iPldlYmRlc2lnbjwvYT4=';
    print base64_decode($jshopxkey);
}

// when value not search add to array and sort 
function insertValueInArray($value, &$array) {
    if ($key = array_search($value, $array)) return $key;
    $array[$value] = $value;
    asort($array);
    return $key - 1;
}

function appendExtendPathWay($array, $page) {
    global $mainframe;
    foreach ($array as $cat) {    
        $mainframe->appendPathway($cat->name, SEFLink('index.php?option=com_jshopping&controller=category&task=view&category_id=' . $cat->category_id));
    }
}

function appendPathWay($page){
    global $mainframe;
    $mainframe->appendPathWay($page, '');
}

class parseString {
    
    var $string = null;
    var $params = null;
    var $separator = null;
    
    function parseString($value, $separator = "\n") {
        $this->separator = $separator;
        if(is_array($value)) {
            $this->params = $value;
        } else
            if(is_string($value)) {
                $this->string = $value;
            } else {
                return;
            }
    }

    // Rozbyvae, koly typ takyi key1=value1 key2=value2
    function parseStringToParams() {
        if(!$this->string)
            return '';
        $params = explode($this->separator, $this->string);
        foreach ($params as $param) {
            $ext_param = explode("=",$param);
            if(!$ext_param[0]) continue;
            $this->params[trim($ext_param[0])] = trim($ext_param[1]);
        }
        return $this->params;
    }

    // Robyt split typu key1=value1 key2=value2
    function splitParamsToString() {
        $this->string = '';
        foreach ($this->params as $key => $value) {
            $this->string .= trim($key) . "=" . trim($value) . $this->separator;
        }
        return $this->string;
    }


    // Rozbyvae, koly typ takyi |value1}value2}
    function parseStringToParams2() {
        $params = explode($this->separator,$this->string);
        foreach ($params as $param) {
            if(!$param)
                continue;
            $this->params[trim($param)] = trim($param);
        }
    }

    function getArrayObject($key_name) {
        $this->parseStringToParams2();
        $arr_ret = array();
        if(!count($this->params))
            return null;
        foreach ($this->params as $param) {
            $obj->$key_name = $param;
            $arr_ret[] = $obj;
            unset($obj);
        }
        return $arr_ret;
    }

    // Robyt split type |value1|value2}
    function splitParamsToString2() {
        $this->string = $this->separator;
        foreach ($this->params as $key => $value) {
            $this->string .= $value . $this->separator;
        }
        return $this->string;
    }
}

function formatprice($price, $currency_code = null) {
    $jshopConfig = &JSFactory::getConfig();

    if (!$currency_code) $currency_code = $jshopConfig->currency_code;
    $price = number_format($price, $jshopConfig->decimal_count, $jshopConfig->decimal_symbol, $jshopConfig->thousand_separator);
	$return = str_replace("Symb", $currency_code, str_replace("00", $price, $jshopConfig->format_currency[$jshopConfig->currency_format]));
    return $return;
}

function formatdate($date, $showtime = 0){
    $jshopConfig = &JSFactory::getConfig();    
    $format = $jshopConfig->store_date_format;
    if ($showtime) $format = $format." %H:%M:%S";
    return strftime($format, strtotime($date));
}

/**
* get system language
* 
* @param int $client (0 - site, 1 - admin)
*/
function getAllLanguages( $client=0 ) {
    $pattern = '#(.*?)\(#is';
    $client	=& JApplicationHelper::getClientInfo($client);    
    $rows	= array ();
    jimport('joomla.filesystem.folder');
    $path = JLanguage::getLanguagePath($client->path);    
    $dirs = JFolder::folders( $path );
    foreach ($dirs as $dir){
        $files = JFolder::files( $path.DS.$dir, '^([-_A-Za-z]*)\.xml$' );
        foreach ($files as $file){
            $data = JApplicationHelper::parseXMLLangMetaFile($path.DS.$dir.DS.$file);
            $row = new StdClass();
            $row->descr = $data['name'];
            $row->language = substr($file,0,-4);
            $row->lang = substr($row->language,0,2);
            $row->name = $data['name'];
            preg_match($pattern, $row->name, $matches);
            $row->name = trim($matches[1]);
            if (!is_array($data)) continue;            
            $rows[] = $row;
        }
    }
    return $rows;
}

function installNewLanguages($defaultLanguage = "", $show_message = 1){
    $db =& JFactory::getDBO();
    $jshopConfig = &JSFactory::getConfig();
    $joomlaLangs = getAllLanguages();
    $query = "select * from #__jshopping_languages";
    $db->setQuery($query);
    $shopLangs = $db->loadObjectList();
    $shopLangsTag = array();
    foreach($shopLangs as $lang){
        $shopLangsTag[] = $lang->language;
    }

    if (!$defaultLanguage) $defaultLanguage = $jshopConfig->defaultLanguage;
    
    foreach($joomlaLangs as $lang){
        if (!in_array($lang->language, $shopLangsTag)){
            $ml = &JSFactory::getLang();
            if ($ml->addNewFieldLandInTables($lang->language, $defaultLanguage)){                
                $query = "insert into #__jshopping_languages set `language`='".$db->getEscaped($lang->language)."', `name`='".$db->getEscaped($lang->name)."', `publish`='1'";
                $db->setQuery($query);
                $db->query();
                if ($show_message){
                    JError::raiseNotice("", _JSHOP_INSTALLED_NEW_LANGUAGES.": ".$lang->name);
                }
            }
        }
    }
}

function recurseTree($cat, $level, $all_cats, &$categories, $is_select) {
    $probil = '';
    if($is_select) {
        for ($i = 0; $i < 2 * $level; $i++) {
            $probil .= '&nbsp;';
        }
        $cat->name = ($probil . $cat->name);        
        $categories[] = JHTML::_('select.option', $cat->category_id, $cat->name,'category_id','name' );
    } else {
        $cat->level = $level;
        $categories[] = $cat;
    }
    foreach ($all_cats as $categ) {
        if($categ->category_parent_id == $cat->category_id) {
            recurseTree($categ, ++$level, $all_cats, $categories, $is_select);
            $level--;
        }
    }
    return $categories;
}

function buildTreeCategory($publish = 1, $is_select = 1) {
	$jshopConfig = &JSFactory::getConfig();
    $db =& JFactory::getDBO();
    $lang = &JSFactory::getLang(); 
    $where_add = ($publish) ? (" where category_publish = '1' ") : ("");
    $query = "SELECT `".$lang->get('name')."` as name,`".$lang->get('description')."` as description, category_id, category_parent_id, category_publish FROM `#__jshopping_categories`
           	  ".$where_add." ORDER BY category_parent_id, category_ordering";
    $db->setQuery($query);
    $all_cats = $db->loadObjectList();
    
    $categories = array();
	if(count($all_cats)) {
        foreach ($all_cats as $key => $value) {
            if(!$value->category_parent_id){
                recurseTree($value, 0, $all_cats, $categories, $is_select);
            }
        }
    }
    return $categories;
}

/**
* check date Format date yyyy-mm-dd
*/
function checkMyDate($date) {
    if (trim($date)=="") return false;
    $arr = explode("-",$date);
    return checkdate($arr[1],$arr[2],$arr[0]);
}

function getDefaultItemid() {
static $Itemid;
	if (!$Itemid){
	    $db = &JFactory::getDBO();
	    $query = "SELECT menu.id FROM `#__menu` AS menu WHERE menu.link = 'index.php?option=com_jshopping&controller=category' AND menu.published = '1'";
	    $db->setQuery($query);
	    $Itemid = $db->loadResult();
	    if (!$Itemid) $Itemid = $_SESSION['shop_default_itemid'];
    }
    return $Itemid;
}

function checkUserLogin() {
    global $mainframe;
    $user = &JFactory::getUser();
    header("Cache-Control: no-cache, must-revalidate");
    if(!$user->id) {
        $return = base64_encode($_SERVER['REQUEST_URI']);
        $_SESSION['return'] = $return;
        $mainframe->redirect(SEFLink('index.php?option=com_jshopping&controller=user&task=login', 0, 1));
        exit();
    }
    return 1;
}

function addLinkToProducts(&$products, $default_category_id = 0, $useDefaultItemId = 0) {
    foreach ($products as $key => $value) {
        $category_id = (!$default_category_id)?($products[$key]->category_id):($default_category_id);
        if (!$category_id) $category_id = 0;
        $products[$key]->product_link = SEFLink('index.php?option=com_jshopping&controller=product&task=view&category_id='.$category_id.'&product_id='.$products[$key]->product_id, $useDefaultItemId);
    }
}

function searchChildCategories($category_id,$all_categories,&$cat_search) {
    foreach ($all_categories as $all_cat) {
        if($all_cat->category_parent_id == $category_id) {
            searchChildCategories($all_cat->category_id, $all_categories, $cat_search);
            $cat_search[] = $all_cat->category_id;
        }
    }
}

function SEFLink($link, $useDefaultItemId = 0, $redirect = 0) {
    $defaultItemid = getDefaultItemid();
    if ($useDefaultItemId){
        $Itemid = $defaultItemid;
        if (!$Itemid) $Itemid = JRequest::getInt('Itemid');
    }else{
        $Itemid = JRequest::getInt('Itemid');
        if (!$Itemid) $Itemid = $defaultItemid;        
    }    
    if($link == "index.php") $link .= '?Itemid=' . $Itemid; else $link .= '&Itemid=' . $Itemid;
   	$link = JRoute::_($link, (($redirect) ? (false) : (true)));    
    return $link;
}

function replaceNbsp($string) {
    return (str_replace(" ","_",$string));
}

function replaceToNbsp($string) {
    return (str_replace("_"," ",$string));
}

function isWritable($directory) {
    $jshopConfig = &JSFactory::getConfig();
    return $return = is_writable($jshopConfig->path . "/" . $directory)?('({ "isWrite" : "1", "text" : "' . _JSHOP_WRITEABLE . '" })'):('({ "isWrite" : "0", "text" : "' . _JSHOP_NON_WRITEABLE . '"})');
}

function sprintRadioList($list, $name, $params, $key, $val, $actived = null){
    $html = "";
    $id = str_replace("[","",$name);
    $id = str_replace("]","",$id);
    foreach($list as $obj){
        if ($obj->$key == $actived) $sel = ' checked="true"'; else $sel = '';
        $html.='<input type="radio" name="'.$name.'" id="'.$id.'" value="'.$obj->$key.'"'.$sel.' '.$params.'> '.$obj->$val;
    }
    return $html;    
}

function saveToLog($file, $text){
    $jshopConfig = &JSFactory::getConfig();
    if (!$jshopConfig->savelog) return 0;
    $f = fopen($jshopConfig->log_path.$file, "a+");
    fwrite($f, date('Y-m-d H:i:s')." ".$text."\r\n");
    fclose($f);
    return 1;
}

function filterHTMLSafe(&$mixed, $quote_style=ENT_QUOTES, $exclude_keys='' ){
    if (is_object( $mixed ))
    {            
        foreach (get_object_vars( $mixed ) as $k => $v)
        {
            if (is_array( $v ) || is_object( $v ) || $v == NULL) {
                continue;
            }

            if (is_string( $exclude_keys ) && $k == $exclude_keys) {
                continue;
            } else if (is_array( $exclude_keys ) && in_array( $k, $exclude_keys )) {
                continue;
            }

            $mixed->$k = htmlspecialchars( $v, $quote_style, 'UTF-8' );
        }
    }
}

function saveAsPrice($val){
    $val = str_replace(",",".",$val);
return floatval($val);
}

function getPriceDiscount($price, $discount){
    return $price - ($price*$discount/100);
}

?>