<?php
/**
* @version      2.0.0 31.07.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

class jshopUserShop extends JTable {
    
	var $user_id = null;
	var $usergroup_id;
	var $u_name = null;
	var $f_name = null;
	var $l_name = null;
	var $firma_name = null;
	var $email = null;
	var $street = null;
	var $zip = null;
	var $city = null;
	var $state = null;
	var $country = null;
	var $phone = null;
	var $fax = null;
	var $title = null;
	var $delivery_adress = null;
	var $d_f_name = null;
	var $d_l_name = null;
	var $d_firma_name = null;
	var $d_street = null;
	var $d_city = null;
	var $d_zip = null;
	var $d_state = null;
    var $d_country = null;
	var $d_phone = null;
	var $d_title = null;

    function __construct( &$_db ){
        parent::__construct( '#__jshopping_users', 'user_id', $_db );
    }   
    
	function isUserInShop($id) {
		$query = "SELECT user_id FROM `#__jshopping_users` WHERE `user_id` = '" . $this->_db->getEscaped($id) . "'";
		$this->_db->setQuery($query);
		$res = $this->_db->query();
		return $this->_db->getNumRows($res);
	}
    	
	function addUserToTableShop($user) {
		$this->u_name = $user->username;
		$this->email = $user->email;
		$this->user_id = $user->id;
        
        $usergroup = &JTable::getInstance('usergroup', 'jshop');
        $default_usergroup = jshopUsergroup::getDefaultUsergroup();
        
		$query = "INSERT INTO `#__jshopping_users` SET `usergroup_id`='".$default_usergroup."', `u_name` = '" . $this->_db->getEscaped($user->username) . "', `email` = '" . $this->_db->getEscaped($user->email) . "', `user_id` = '" . $this->_db->getEscaped($user->id) . "' ";
		$this->_db->setQuery($query);
		$this->_db->query();
	}

	function check($checkout = 0) {
		jimport('joomla.mail.helper');
        
        if(!intval($this->title)) {
            $this->_error = addslashes(_JSHOP_REGWARN_TITLE);
            return false;
        }
                		
		if(trim($this->f_name) == '') {
			$this->_error = addslashes(_JSHOP_REGWARN_NAME);
			return false;
		}

		if(trim($this->l_name) == '') {
			$this->_error = addslashes(_JSHOP_REGWARN_LNAME);
			return false;
		}

		if( (trim($this->email == "")) || ! JMailHelper::isEmailAddress($this->email)) {
			$this->_error = addslashes(_JSHOP_REGWARN_MAIL);
			return false;
		}

		if(!$checkout) {
            
			if(trim($this->u_name) == '') {
				$this->_error = addslashes(_JSHOP_REGWARN_UNAME);
				return false;
			}
			if(strlen($this->u_name) > 25) {
				$this->u_name = substr($this->u_name,0,25);
			}

            if (preg_match( "#[<>\"'%;()&]#i", $this->u_name) || strlen(utf8_decode($this->u_name )) < 2) {
                $this->_error = sprintf(addslashes(_JSHOP_VALID_AZ09),addslashes(_JSHOP_USERNAME),2);
                return false;
            }

			// check for existing username
			$query = "SELECT id FROM #__users WHERE username = '" . $this->_db->getEscaped($this->u_name) . "' AND id != " . (int)$this->user_id;
			$this->_db->setQuery($query);
			$xid = intval($this->_db->loadResult());
			if($xid && $xid != intval($this->user_id)) {
				$this->_error = addslashes(_JSHOP_REGWARN_INUSE);
				return false;
			}                        
			
		}
        
        // check for existing email
        $query = "SELECT id FROM #__users WHERE email = '" . $this->_db->getEscaped($this->email) . "' AND id != " . (int)$this->user_id;
        $this->_db->setQuery($query);
        $xid = intval($this->_db->loadResult());
        if($xid && $xid != intval($this->id)) {
            $this->_error = addslashes(_JSHOP_REGWARN_EMAIL_INUSE);
            return false;
        }

		if(trim($this->street) == '') {
			$this->_error = addslashes(_JSHOP_REGWARN_STREET);
			return false;
		}

		
		if (trim($this->zip) == ""){
		    $this->_error = addslashes( _JSHOP_REGWARN_ZIP );
		    return false;
		}
        
		if (trim($this->city) == ''){
		    $this->_error = addslashes( _JSHOP_REGWARN_CITY );
		    return false;
		}		
        
        if (trim($this->state) == ''){
            $this->_error = addslashes( _JSHOP_REGWARN_STATE ); //region
            return false;
        }
        
		if(!intval($this->country)) {
			$this->_error = addslashes(_JSHOP_REGWARN_COUNTRY);
			return false;
		}		
        		
		if(trim($this->phone) == '') {
		    $this->_error = addslashes(_JSHOP_REGWARN_PHONE);
		    return false;
		}		
        
		if($checkout) {
			if($this->delivery_adress) {
				if(trim($this->d_f_name) == '') {
					$this->_error = addslashes(_JSHOP_REGWARN_NAME_DELIVERY);
					return false;
				}

				if(trim($this->d_l_name) == '') {
					$this->_error = addslashes(_JSHOP_REGWARN_LNAME_DELIVERY);
					return false;
				}

				if(trim($this->d_street) == '') {
					$this->_error = addslashes(_JSHOP_REGWARN_STREET_DELIVERY);
					return false;
				}

				
                if (trim($this->d_zip) == ""){
				    $this->_error = addslashes( _JSHOP_REGWARN_ZIP_DELIVERY );
				    return false;
				}

				if (trim($this->d_state) == ''){
				    $this->_error = addslashes( _JSHOP_REGWARN_STATE_DELIVERY );
				    return false;
				}
                
				if(!intval($this->d_country)) {
                    $this->_error = addslashes(_JSHOP_REGWARN_COUNTRY_DELIVERY);
                    return false;
                }
                
				if(!intval($this->d_title)) {
					$this->_error = addslashes(_JSHOP_REGWARN_TITLE_DELIVERY);
					return false;
				}
				
				if(trim($this->d_phone) == '') {
				    $this->_error = addslashes(_JSHOP_REGWARN_PHONE_DELIVERY);
				    return false;
				}
                
			}
		}        

		return true;
	}
    
	function getCountryId($id_user) {
		$db =& JFactory::getDBO(); 
		$query = "SELECT country FROM `#__jshopping_users` WHERE user_id = '" . $db->getEscaped($id_user) . "'";
		$db->setQuery($query);
		return $db->loadResult();

	}
	
	function getDiscount(){
		$db =& JFactory::getDBO(); 
		$query = "SELECT usergroup.usergroup_discount FROM `#__jshopping_usergroups` AS usergroup
				  INNER JOIN `#__jshopping_users` AS users ON users.usergroup_id = usergroup.usergroup_id
				  WHERE users.user_id = '" . $db->getEscaped($this->user_id) . "' ";
		$db->setQuery($query);
		return floatval($db->loadResult());
	}
    
    function getError(){
        return $this->_error;
    }
    
}

?>